'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getConfig = undefined;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _process = require('process');

var _process2 = _interopRequireDefault(_process);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var config = void 0;

var configFileName = '.saulrc';

// @t "gets existing config" getConfig({foo: "bar"}) ~deep-equals {foo: 'bar'}
// @t "must read and get config"
//     getConfig(null, () => '{"good": "config"}', 'fakePath') ~deep-equals {good: 'config'}
// @t "must return default config on bad config"
//     getConfig(null, null, 'fakePath') ~deep-equals {fileGlob: '**/*.js'}
var getConfig = exports.getConfig = function getConfig() {
  var existingConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : config;
  var readFile = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _fs2.default.readFileSync;
  var configPath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _path2.default.join(_process2.default.cwd(), configFileName);

  if (existingConfig) {
    return existingConfig;
  }

  try {
    config = JSON.parse(readFile(configPath, 'utf-8'));
  } catch (e) {
    console.log('Warning: Could not find a valid .saulrc in ' + _process2.default.cwd());

    config = {
      fileGlob: '**/*.js'
    };
  }

  return config;
};