'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.composeParams = exports.composeArgs = exports.getFileContent = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _types = require('./types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @t "reads file" getFileContent('fakeFilePath', spy('reader')) ~expect-spy expect(spy('reader').calledOnce).to.equal(true)
var getFileContent = exports.getFileContent = function getFileContent(filepath) {
  var readFile = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _fs2.default.readFileSync;
  return readFile(filepath, 'utf-8');
};

// @t "not foo" composeArgs(['1', '2']) ~is-not foo
var composeArgs = exports.composeArgs = function composeArgs(match) {
  var _match = _slicedToArray(match, 6),
      fullMatch = _match[0],
      testDescription = _match[1],
      funcName = _match[2],
      args = _match[3],
      engineName = _match[4],
      output = _match[5]; // eslint-disable-line no-unused-vars

  return {
    args: args,
    engineName: engineName,
    funcName: funcName,
    output: output,
    testDescription: testDescription
  };
};

var composeParams = exports.composeParams = function composeParams(fileContent) {
  var testLine = /(?:\/\/\s@t\s)(".*")(?:[^\w])+([\w|\.]+)\((.*)(?:\)[^\w])+~((?:\w|-)+)(?:[\s]?)+(.*)/g;

  var match = void 0;
  var paramsArray = [];

  while ((match = testLine.exec(fileContent)) !== null) {
    paramsArray.push(composeArgs(match));
  }

  return paramsArray;
};

/* istanbul ignore next */
var parse = function parse(filepath) {
  try {
    return (0, _lodash2.default)(filepath).thru(getFileContent).thru(composeParams).value();
  } catch (e) {
    throw new Error('Error parsing your test files');
  }
};

exports.default = parse;