'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateSpy = exports.getSpy = undefined;

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var generated = {};

// @t "gets existing spy"
//    getSpy('iSpy', { 'iSpy': { name: 1337 } }, () => {}) ~deep-equals { name: 1337 }
var getSpy = exports.getSpy = function getSpy(name) {
  var collection = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : generated;

  if (collection[name]) {
    return collection[name];
  }

  throw new Error('Could not find spy: ' + name);
};

// @t "generates a new spy"
//    generateSpy('spyName', {}, {}) ~deep-equals { _saul_type: 'spy', _saul_name: 'spyName' }
// @t "throws on existing spy name"
//    generateSpy('existingSpy', { 'existingSpy': {} }, {}) ~throws true
var generateSpy = exports.generateSpy = function generateSpy(name) {
  var collection = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : generated;
  var newSpy = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _sinon2.default.spy();

  if (collection[name]) {
    throw new Error('Spy name ' + name + ' is already taken.');
  }

  var spy = Object.assign(newSpy, {
    _saul_type: 'spy',
    _saul_name: name
  });

  collection[name] = spy;

  return spy;
};